<?php
/*
Plugin Name: CubePoints Buddypress Integration
Version: 1.5.1
Plugin URI: http://blog.slyspyder.com/2010/04/21/cubepoints-buddypress-integration-wordpress-plugin/
Description: Adds CubePoints support to Buddypress. Reward members using your BuddyPress portion of your website by giving them points! Members get points for Group Creation, Updates/Replies, Friend Request/Accept, New Group Forum, Group Forum Post, Uploading Avatar, sending messages, adding links.
Author: Tosh Hatch
Author URI: http://www.SlySpyder.com
*/

/* **********************************************
To change the point values change ONLY the numbers in the code below and NOTHING else. 
To disable points for an activity. Change the point value to 0
********************************************** */

// BuddyPress aware
function cubepointsbp() {

// Add 100 Points for creating a group
function my_bp_create_group_add_cppoints() {
if( function_exists('cp_alterPoints') && is_user_logged_in() ){
cp_alterPoints(cp_currentUser(), 100);
cp_log('Group Creation', cp_currentUser(), 100, BuddyPress);
}
}
add_action('groups_group_create_complete','my_bp_create_group_add_cppoints');

// Add 5 Points for a update
function my_bp_update_post_add_cppoints() {
if( function_exists('cp_alterPoints') && is_user_logged_in() ){
cp_alterPoints(cp_currentUser(), 5);
cp_log('Comment', cp_currentUser(), 5, BuddyPress);
}
}
add_action('bp_activity_posted_update','my_bp_update_post_add_cppoints');

// Add 5 Points for a comment or reply
function my_bp_update_comment_add_cppoints() {
if( function_exists('cp_alterPoints') && is_user_logged_in() ){
cp_alterPoints(cp_currentUser(), 5);
cp_log('Comment', cp_currentUser(), 5, BuddyPress);
}
}
add_action('bp_activity_comment_posted','my_bp_update_comment_add_cppoints');

// Add 5 Points for a GROUP comment or reply
function my_bp_update_group_add_cppoints() {
if( function_exists('cp_alterPoints') && is_user_logged_in() ){
cp_alterPoints(cp_currentUser(), 5);
cp_log('Group Comment', cp_currentUser(), 5, BuddyPress);
}
}
add_action('bp_groups_posted_update','my_bp_update_group_add_cppoints');

// Remove 5 points for comment deletion
function my_bp_delete_comment_add_cppoints() {
if( function_exists('cp_alterPoints') && is_user_logged_in() ){
cp_alterPoints(cp_currentUser(), -5);
cp_log('Comment Removed', cp_currentUser(), -5, BuddyPress);
}
}
add_action('bp_activity_action_delete_activity','my_bp_delete_comment_add_cppoints');

// Add 15 Points for Accepting a Friend Request
function my_bp_friend_add_cppoints() {
if( function_exists('cp_alterPoints') && is_user_logged_in() ){
cp_alterPoints(cp_currentUser(), 15);
cp_log('Friend Added', cp_currentUser(), 15, BuddyPress);
}
}
add_action('friends_friendship_accepted','my_bp_friend_add_cppoints');

// Add 15 Points for Friend Request
function my_bp_friend_request_add_cppoints() {
if( function_exists('cp_alterPoints') && is_user_logged_in() ){
cp_alterPoints(cp_currentUser(), 15);
cp_log('Friend Request', cp_currentUser(), 15, BuddyPress);
}
}
add_action('friends_friendship_requested','my_bp_friend_request_add_cppoints');

//  Add 20 Points New Group Forum Topic (See FAQ in readme.txt for more info)
function my_bp_forum_new_topic_add_cppoints() {
if( function_exists('cp_alterPoints') && is_user_logged_in() ){
cp_alterPoints(cp_currentUser(), 20);
cp_log('New Group Forum Topic', cp_currentUser(), 20, BuddyPress);
}
}
add_action('bp_forums_new_topic','my_bp_forum_new_topic_add_cppoints');

// Add 5 Points New Group Forum Post
function my_bp_forum_new_post_add_cppoints() {
if( function_exists('cp_alterPoints') && is_user_logged_in() ){
cp_alterPoints(cp_currentUser(), 5);
cp_log('Group Forum Post', cp_currentUser(), 5, BuddyPress);
}
}
add_action('bp_forums_new_post','my_bp_forum_new_post_add_cppoints');

// Add 5 Points Avatar Upload
function my_bp_avatar_add_cppoints() {
if( function_exists('cp_alterPoints') && is_user_logged_in() ){
cp_alterPoints(cp_currentUser(), 5);
cp_log('Avatar Uploaded', cp_currentUser(), 5, BuddyPress);
}
}
add_action('xprofile_avatar_uploaded','my_bp_avatar_add_cppoints');

// Add 1 Point Message Sent
function my_bp_pm_cppoints() {
if( function_exists('cp_alterPoints') && is_user_logged_in() ){
cp_alterPoints(cp_currentUser(), 1);
cp_log('Message Sent', cp_currentUser(), 1, BuddyPress);
}
}
add_action('messages_message_sent','my_bp_pm_cppoints');

// REQUIRES THIS PLUGIN - http://wordpress.org/extend/plugins/buddypress-links/
// Add 5 Points for BuddyPress Link Creation
function my_bp_bplink_add_cppoints() {
if( function_exists('cp_alterPoints') && is_user_logged_in() ){
cp_alterPoints(cp_currentUser(), 5);
cp_log('Link Added', cp_currentUser(), 5, BuddyPress);
}
}
add_action('bp_links_create_complete','my_bp_bplink_add_cppoints');

// Add BP CubePoints Admin Menu
function cubebpth_add_admin_menu() {
	global $bp;

	if ( !$bp->loggedin_user->is_site_admin )
		return false;

	require ( dirname( __FILE__ ) . '/cubeBPconfig.php' );

	add_submenu_page( 'bp-general-settings', __( 'Cubepoints BuddyPress Integration', 'cbbp-config' ), __( 'BP CubePoints', 'cbbp-config' ), 'manage_options', 'cubebp-settings', 'cubebp_admin' );
}
add_action( 'admin_menu', 'cubebpth_add_admin_menu' );
// END BP CubePoints Admin Menu


// END BuddyPress aware
}

if ( defined( 'BP_VERSION' ) )
	cubepointsbp();
else
	add_action( 'bp_init', 'cubepointsbp' );
// END BuddyPress aware

?>